//****************************************************************************
//	aisa41s.pas
//
//	aISA-P41
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 1998/05/28
//
//	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
//
//****************************************************************************
unit aisa41s;

interface

uses
	Windows, Messages, SysUtils, Forms, aisa41w;

const
	szTitle = 'Sample';
	szName = 'aISA-P41';

type
	TForm1 = class(TForm)
		procedure FormCreate(Sender: TObject);
	private
		procedure ResultMessage(strbuf: String);
		procedure ErrorMessage(wLogSlot: Word);
	public
		{ Public 錾 }
	end;

var
	Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
	strbuf:	 String;
	dwDLLVer, dwDrvVer: DWord;	// DLLCDrivero[W
	bResult:	Boolean;					// 
	wLogSlot: Word;							// foCXi[
	dwDirections: DWord;				// fBNV
	InValue:	Byte;							// o̓f[^
	OutValue: Byte;
	ri:				TAISA41RESOURCE;	// \[X
begin
//---------------------------------------------------------------------------
	// aisa41.dll ̎gp錾
	if Aisa41wDllOpen() = False then
	begin
		ErrorMessage(AISA41_SLOT_AUTO);
		Exit;			// aisa41.dll ̃[hɎs܂
	end;

//---------------------------------------------------------------------------
	// o[Wԍ\
	// aISA-P41 DLL,Driver̃o[Wԍ擾
	if Aisa41wGetVersion(dwDLLVer, dwDrvVer) = False then
	begin
		ErrorMessage(AISA41_SLOT_AUTO);
		Exit;
	end;

	strbuf := Format('GetVersion'#10 +
					 'DLL Version: %08xH'#10 +
					 'Drv Version: %08xH',
										 [dwDLLVer, dwDrvVer]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// aISA-P41̎gp錾
	wLogSlot := AISA41_SLOT_AUTO;				// gp̃foCXT܂B
	bResult := Aisa41wCreate(wLogSlot);	// ꍇA̎̃foCXi[܂B

	if bResult = False then		// foCX܂B
	begin
		ErrorMessage(AISA41_SLOT_AUTO);
		Exit;
	end;

	strbuf := Format('aISA-P41 Created'#10#10 +
									 'LogSlot: %2d', [wLogSlot]);

	ResultMessage(strbuf);


//---------------------------------------------------------------------------
	// \[X擾
	if Aisa41wGetResource(wLogSlot, @ri) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := Format('Board Name: %s'#10 +
						 'NumPorts: %2d'#10 +
						 'IO Address: %04xH -%04xH'#10,
											[szName, ri.dwIOPortLength[1],
											ri.dwIOPortBase[1],
											ri.dwIOPortBase[1] + ri.dwIOPortLength[1] - 1]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
// A Port ̃fBNVo͂ɐݒ
	// A Port ̃rbgo͂ɕύX܂B
	dwDirections := 0;
	dwDirections := not(AISA41_DIR_A_INPUT) and dwDirections;

	// fBNVZbg
	if Aisa41wSetDirections(wLogSlot, dwDirections) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	ResultMessage('Port ÃfBNVo͂ɕύX');

//---------------------------------------------------------------------------
	// Port A ɔCӂ̃f[^o
	// o̓f[^ AAh
	OutValue := Byte($AA);

	if Aisa41wOutPort(wLogSlot, AISA41_PORT_A, OutValue) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := Format('Port A փf[^o'#10 +
					 'Port A Out Data: %02xH',
					 [OutValue]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// A Port ̃fBNV͂ɐݒ
	// A Port ̃rbg͂ɕύX܂B
	dwDirections := AISA41_DIR_A_INPUT or dwDirections;

	// fBNVZbg
	if Aisa41wSetDirections(wLogSlot, dwDirections) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	ResultMessage('Port A ̃fBNV͂ɕύX');

//---------------------------------------------------------------------------
	// Port A f[^ǂݍ
	InValue := Byte($00);

	if Aisa41wInPort(wLogSlot, AISA41_PORT_A, InValue) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := Format('Port A f[^'#10 +
					 'Port A In Data: %02xH',
					 [InValue]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// aISA-P41̎gpJ
	if Aisa41wClose(wLogSlot) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	ResultMessage('aISA-P41 Closed');

	// aisa41.dll ̎gpJ
	if Aisa41wDllClose() = False then
	begin
		Application.MessageBox(PChar('DLL ̃A[hɎs܂B'), szTitle, MB_OK + MB_ICONSTOP);
		Exit;			// aisa41.dll ̃A[hɎs܂B
	end;

end;

// ʂ\
procedure TForm1.ResultMessage(strbuf: String);
begin
	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONINFORMATION);
end;

// G[bZ[W\
procedure TForm1.ErrorMessage(wLogSlot: Word);
var
	dwRes: DWord;
	strbuf: String;
begin
	dwRes := Aisa41wGetLastError(wLogSlot);

	case dwRes of
		AISA41_ERR_SYSTEM:
			strbuf := Format('System error'#10#10'Error code: %08xH', [GetLastError()]);

		AISA41_ERR_WRAPDLL:
			strbuf := 'DLL Load error';
	else
		strbuf := Format('aISA-P41 error'#10#10'Error code: %08xH',[dwRes]);
	end;

	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONSTOP);
end;

end.
